'PSB TinyFont Demo (C) Copyright 2009 Rayslogic.com, LLC
' Demos a 6x10 font for 80 column display

CON

  _clkmode = xtal1+pll16x
  _clkfreq = 80_000_000


  'LCD is 480x272 giving 30x17 tiles
  cols = 80
  rows = 28  '27 full rows plus one extra for the bottom two rows...
  screensize = cols * rows



VAR

  long  lcd_status      'status: off/visible/invisible  read-only       (5 contiguous longs)
  long  lcd_enable      'enable: off/on                 write-only
  long  lcd_videobase   'video base @word               write-only
  long  lcd_colorbase   'color base @long               write-only
  long  lcd_backlight   'Used to control LCD backlight
  long  lcd_pFont       'Used to pass address of font

  word  screen[screensize]
  long  col, row, color
  long  boxcolor,ptr




OBJ
  lcd : "PSB_TinyLcdDriver"  'Modified to drive 4.3" TFT
  i2c: "PSB_I2CDriver"  

pub Main|i
  
  'Start up Display
  'clear screen
  print($100)
  'start driver
  lcd_enable:=1
  lcd_videobase := @screen
  lcd_colorbase := @vgacolors
  lcd_backlight:=3  '1=bright, 16=medium, 32=dark
  lcd_pFont:=@TinyFont 'pass address of font
  lcd.start(@lcd_status)

  i2c.initialize
  
  repeat 10
    
    repeat i from 0 to 255
      print(i)
    color++

  
  repeat



                            
   



      


PUB WaitStylusUp
  'Wait for stylus to be up
  repeat
    waitcnt(cnt+clkfreq/100)  
    if ina[lcd#TouchIrqPin]<>0
    return


PRI PrintStr(stringptr)

'' Print a zero-terminated string

  repeat strsize(stringptr)
    print(byte[stringptr++])

PUB print(c) | i, k

  case c
    $00..$FF:           'character?
      i := color<<8 +  c
      screen[row * cols + col] := i
      if ++col == cols
        newline

    $100:               'clear screen?
      wordfill(@screen, $20, screensize)
      col := row := 0

    $108:               'backspace?
      if col
        col--

    $10D:               'return?
      newline

    $110..$11F:         'select color?
      color := c & $F


' New line

PRI newline : i

  col := 0
  if (row += 1) == rows
    row -= 1
    'scroll lines
    repeat i from 0 to rows-3
'      wordmove(@screen[i*cols], @screen[(i+2)*cols], cols)
    'clear new line
'    wordfill(@screen[(rows-2)*cols], $200, cols<<1)


' Data

PRI dec(value) | i

'' Print a decimal number

  if value < 0
    -value
    print("-")

  i := 1_000_000_000

  repeat 10
    if value => i
      print(value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      print("0")
    i /= 10

PRI hex(value, digits)

'' Print a hexadecimal number

  value <<= (8 - digits) << 2
  repeat digits
    print(lookupz((value <-= 4) & $F : "0".."9", "A".."F"))
    
DAT 'Default Touchscreen Calibrations
touchx0 long 2713
touchdx long 123
touchy0 long 4590
touchdy long 206

TinyFont byte
file "hobtiny8.dat"

DAT

vgacolors               long
                        long    $F00CF00C       'blue background with yellow letters
                        long    $F0F08000
                        long    $08A808A8       'green
                        long    $0808A89C
                        long    $50005000       'blue
                        long    $50500020
                        long    $FC00FF00       'white
                        long    $FCFC9C00
                        long    $FF80FF80       'red/white
                        long    $FFFF8080
                        long    $FF20FF20       'green/white
                        long    $FFFF2020
                        long    $FF28FF28       'cyan/white
                        long    $FFFF2828
                        long    $00A800A8       'grey/black
                        long    $0000A8A8
                        long    $FFC03000      '16'Colors for Graphics
spcl                    long    $F0FF9C0C       '17 'Color0  white
                        long    $F0C09C0C        '18 Color1  red
                        long    $F030000C      '19 Color2  green
                        long    $F000000C      '20 Color3  black
                        long    $FF0C9C0C        '21 fill screen
                        long    $000C9C0C        '22 clear screen
                        long    $FF0C9C0C        '23 line mode
                        long    $FF0C9C0C        '24 dots mode 
                        long    0